<template>
    <Head title="Типы товаров" />
    <div class="g-titlebar">
        <h1>Типы товаров</h1>
        <Link href="/product_types/create/" class="g-button outlined"> Создать тип товара </Link>
    </div>
    <b-filter
        v-model="filter"
        :fields="{
            category: {
                type: 'treeSelect',
                placeholder: 'Все категории',
                options: categoryTree,
            },
            q: {
                type: 'text',
                placeholder: 'Поиск по названию / URL',
            },
            stage: {
                type: 'select',
                placeholder: 'Все стадии',
                options: stageTitles,
            },
        }"
    />
    <el-table :data="productTypes.data" table-layout="auto" :class="{ loading: filter.loading }">
        <el-table-column prop="productCategoryTitle" label="Категория" />
        <el-table-column label="Название">
            <template #default="{ row }">
                <Link :href="`/product_types/${row.name}/product_props/`">
                    {{ row.title }}
                </Link>
            </template>
        </el-table-column>
        <el-table-column label="URL">
            <template #default="{ row }">/{{ row.slug }}/</template>
        </el-table-column>
        <el-table-column label="Стадия">
            <template #default="{ row }">
                <el-tag :type="row.isPublished ? 'success' : 'info'">
                    {{ stageTitles[row.stage] || row.stage }}
                </el-tag>
            </template>
        </el-table-column>
        <el-table-column label="Контент-Менеджеры">
            <template #default="{ row }">
                <Link :href="`/users/${row.leadContentId}/`" v-if="row.leadContentId">
                    {{ row.leadContentName }}
                </Link>
            </template>
        </el-table-column>
        <el-table-column align="right">
            <template #default="{ row }">
                <a @click="deleteProductType(row.name, row.title)" title="Удалить" class="g-actionicon">
                    <font-awesome-icon icon="trash" />
                </a>
                <Link :href="`/product_types/${row.name}/product_props/`" title="Характеристики" class="g-actionicon">
                    <font-awesome-icon icon="sliders" />
                </Link>
                <Link :href="`/product_types/${row.name}/edit/`" title="Редактировать" class="g-actionicon">
                    <font-awesome-icon icon="pen-to-square" />
                </Link>
            </template>
        </el-table-column>
    </el-table>
    <b-pagination :links="productTypes.links" />
</template>

<script>
import { router } from "@inertiajs/vue3";
export default {
    props: {
        productTypes: Object,
        stageTitles: Object,
        categoryTree: Array,
        initialFilter: Object,
    },
    data() {
        return {
            filter: { ...this.initialFilter },
        };
    },
    methods: {
        deleteProductType(name, title) {
            if (!confirm(`Вы действительно хотите удалить тип товара «${title}»?`)) return;
            router.delete(`/product_types/${name}/`);
        },
    },
};
</script>
